/*
/// Form
*/

main form {
  margin: auto;
  padding: var(--baseline) calc(var(--baseline));
  max-width: 40em;
  background: var(--color-primary-verylight);
}

fieldset > *:not(textarea) {
  overflow: hidden;
  padding: 0.2em;
}

legend {
  margin-bottom: calc(var(--baseline) * 2 );
  line-height: 1;
  color: var(--color-gray-700);
}

.form__required {
  display: block;
  float: right;
  padding: 0.3em;
  font-size: var(--text-xs);
}

form label {
  display: flex;
  align-items: center;
  justify-content: space-between;
  order: -1;
  width: 100%;
  height: var(--baseline);
  font-weight: bold;
  text-transform: uppercase;
  color: var(--color-gray-700);
}

input[type=text]:focus-visible,
input[type=url]:focus-visible,
input[type=tel]:focus-visible,
input[type=date]:focus-visible,
input[type=email]:focus-visible,
input[type=password]:focus-visible,
input[type=number]:focus-visible,
textarea:focus-visible {
  outline-offset: 2px;
}

input[type=text],
input[type=url],
input[type=tel],
input[type=date],
input[type=email],
input[type=password],
input[type=number],
textarea {
  font-size: 1em;
  vertical-align: middle;
  border: 1px solid var(--color-gray-700);
  background-color: #fff;
}

input[type=text]:optional,
input[type=url]:optional,
input[type=tel]:optional,
input[type=date]:optional,
input[type=email]:optional,
input[type=password]:optional,
input[type=number]:optional {
  border-color: var(--color-gray-100);
}

input[type=text]:required,
input[type=url]:required,
input[type=tel]:required,
input[type=date]:required,
input[type=email]:required,
input[type=password]:required,
input[type=number]:required {
  border-color: var(--color-gray);
}

input[type=text]:focus,
input[type=url]:focus,
input[type=tel]:focus,
input[type=date]:focus,
input[type=email]:focus,
input[type=password]:focus,
input[type=number]:focus {
  border-color: var(--color-primary);
}

input[type=text]:disabled,
input[type=url]:disabled,
input[type=tel]:disabled,
input[type=date]:disabled,
input[type=email]:disabled,
input[type=password]:disabled,
input[type=number]:disabled {
  cursor: not-allowed;
  background-color: var(--color-gray-100);
}

input[type=text]:not(:placeholder-shown),
input[type=url]:not(:placeholder-shown),
input[type=tel]:not(:placeholder-shown),
input[type=date]:not(:placeholder-shown),
input[type=email]:not(:placeholder-shown),
input[type=password]:not(:placeholder-shown),
input[type=number]:not(:placeholder-shown) {
  border-color: var(--color-gray-100);
  box-shadow: none;
}

input[type=text]:not(:placeholder-shown):valid,
input[type=url]:not(:placeholder-shown):valid,
input[type=tel]:not(:placeholder-shown):valid,
input[type=date]:not(:placeholder-shown):valid,
input[type=email]:not(:placeholder-shown):valid,
input[type=password]:not(:placeholder-shown):valid,
input[type=number]:not(:placeholder-shown):valid {
  border-color: hsl(var(--base-green), var(--base-sat), var(--base-light));
  box-shadow: none;
}

input[type=text]:not(:placeholder-shown):invalid,
input[type=url]:not(:placeholder-shown):invalid,
input[type=tel]:not(:placeholder-shown):invalid,
input[type=date]:not(:placeholder-shown):invalid,
input[type=email]:not(:placeholder-shown):invalid,
input[type=password]:not(:placeholder-shown):invalid,
input[type=number]:not(:placeholder-shown):invalid {
  border-color: hsl(var(--base-red), var(--base-sat), var(--base-light));
  box-shadow: none;
}

.hf-warning {
  overflow: hidden;
  margin: calc(var(--baseline) / -2) 0 calc(var(--baseline) / 2);
  font-size: 75%;
  color: hsl(var(--base-red), var(--base-sat), var(--base-light));
}
